"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from formance_sdk_python.models.shared import (
    createbalancerequest as shared_createbalancerequest,
    createbalanceresponse as shared_createbalanceresponse,
)
from formance_sdk_python.types import BaseModel
from formance_sdk_python.utils import (
    FieldMetadata,
    HeaderMetadata,
    PathParamMetadata,
    RequestMetadata,
)
import httpx
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class CreateBalanceRequestTypedDict(TypedDict):
    id: str
    create_balance_request: NotRequired[
        shared_createbalancerequest.CreateBalanceRequestTypedDict
    ]
    idempotency_key: NotRequired[str]
    r"""Use an idempotency key"""


class CreateBalanceRequest(BaseModel):
    id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]

    create_balance_request: Annotated[
        Optional[shared_createbalancerequest.CreateBalanceRequest],
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ] = None

    idempotency_key: Annotated[
        Optional[str],
        pydantic.Field(alias="Idempotency-Key"),
        FieldMetadata(header=HeaderMetadata(style="simple", explode=False)),
    ] = None
    r"""Use an idempotency key"""


class CreateBalanceResponseTypedDict(TypedDict):
    content_type: str
    r"""HTTP response content type for this operation"""
    status_code: int
    r"""HTTP response status code for this operation"""
    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""
    create_balance_response: NotRequired[
        shared_createbalanceresponse.CreateBalanceResponseTypedDict
    ]
    r"""Created balance"""


class CreateBalanceResponse(BaseModel):
    content_type: str
    r"""HTTP response content type for this operation"""

    status_code: int
    r"""HTTP response status code for this operation"""

    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""

    create_balance_response: Optional[
        shared_createbalanceresponse.CreateBalanceResponse
    ] = None
    r"""Created balance"""
