"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from formance_sdk_python.models.shared import (
    connector as shared_connector,
    connectorconfig as shared_connectorconfig,
    connectorresponse as shared_connectorresponse,
)
from formance_sdk_python.types import BaseModel
from formance_sdk_python.utils import FieldMetadata, PathParamMetadata, RequestMetadata
import httpx
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class InstallConnectorRequestTypedDict(TypedDict):
    connector_config: shared_connectorconfig.ConnectorConfigTypedDict
    connector: shared_connector.Connector
    r"""The name of the connector."""


class InstallConnectorRequest(BaseModel):
    connector_config: Annotated[
        shared_connectorconfig.ConnectorConfig,
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ]

    connector: Annotated[
        shared_connector.Connector,
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""The name of the connector."""


class InstallConnectorResponseTypedDict(TypedDict):
    content_type: str
    r"""HTTP response content type for this operation"""
    status_code: int
    r"""HTTP response status code for this operation"""
    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""
    connector_response: NotRequired[shared_connectorresponse.ConnectorResponseTypedDict]
    r"""OK"""


class InstallConnectorResponse(BaseModel):
    content_type: str
    r"""HTTP response content type for this operation"""

    status_code: int
    r"""HTTP response status code for this operation"""

    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""

    connector_response: Optional[shared_connectorresponse.ConnectorResponse] = None
    r"""OK"""
