"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from formance_sdk_python.models.shared import (
    connector as shared_connector,
    connectorconfig as shared_connectorconfig,
)
from formance_sdk_python.types import BaseModel
from formance_sdk_python.utils import FieldMetadata, PathParamMetadata, RequestMetadata
import httpx
import pydantic
from typing_extensions import Annotated, TypedDict


class UpdateConnectorConfigV1RequestTypedDict(TypedDict):
    connector_config: shared_connectorconfig.ConnectorConfigTypedDict
    connector: shared_connector.Connector
    r"""The name of the connector."""
    connector_id: str
    r"""The connector ID."""


class UpdateConnectorConfigV1Request(BaseModel):
    connector_config: Annotated[
        shared_connectorconfig.ConnectorConfig,
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ]

    connector: Annotated[
        shared_connector.Connector,
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""The name of the connector."""

    connector_id: Annotated[
        str,
        pydantic.Field(alias="connectorId"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""The connector ID."""


class UpdateConnectorConfigV1ResponseTypedDict(TypedDict):
    content_type: str
    r"""HTTP response content type for this operation"""
    status_code: int
    r"""HTTP response status code for this operation"""
    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""


class UpdateConnectorConfigV1Response(BaseModel):
    content_type: str
    r"""HTTP response content type for this operation"""

    status_code: int
    r"""HTTP response status code for this operation"""

    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""
